
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>《React Native移动开发实战》一一2.4  React Native的Flexbox布局 / iVAN</title>

    <meta name="description" content="《React Native移动开发实战》一一2.4  React Native的Flexbox布局 2.4 React Native的Flexbox布局无论是在移动平台还是Web前端开发中,布局技术都是必不可少的.了解Web开发的读者想必都听说过著名的CSS&quot;盒子模型&quot;,如图2.4所示. 图2.4 CSS&quot;盒子模型&quot;CSS&quot;盒子模型&quot;依赖于position属性.浮动属性以及display属性来进行布局,所以,对于一些特殊但常用的布局(例如垂直居中)实现就比较困难.于是,在2009年,W3C提出了一种新的方案--Flexbox布局.Fl ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">《React Native移动开发实战》一一2.4  React Native的Flexbox布局</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>2.4  React Native的Flexbox布局<br />无论是在移动平台还是Web前端开发中，布局技术都是必不可少的。了解Web开发的读者想必都听说过著名的CSS“盒子模型”，如图2.4所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzUwODJkNjg4NjhhMTAxMGU2NTgxNWM1NmIwY2E3MzNjNzg0N2JmMDYucG5n.jpg"></p>
<p>图2.4  CSS“盒子模型”<br />CSS“盒子模型”依赖于position属性、浮动属性以及display属性来进行布局，所以，对于一些特殊但常用的布局（例如垂直居中）实现就比较困难。<br />于是，在2009年，W3C提出了一种新的方案——Flexbox布局。Flexbox（Flexible Box的缩写，又称弹性盒子布局）布局旨在提供一个更加有效的方式制定、调整和分布一个容器里的项目布局，即使他们的大小是未知或者动态的。Flexbox布局的主要思想是让容器有能力让其子项目能够改变其宽度、高度（甚至顺序），以最佳方式填充可用空间（主要是为了适应所有类型的显示设备和屏幕大小）。<br />?小知识：W3C（World Wide Web Consortium）指万维网联盟，该组织建立于1994年，其宗旨是通过促进通用协议的发展并确保其通用型，以激发Web世界的全部潜能。<br />目前，主流浏览器都已经很好地支持Flexbox布局，如图2.5所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzUxYTRiYjcxNjVlZjhlYjI5ZjA0ZDRiZGY3NzY1ZTc5ZGQ3YTMxMTQucG5n.jpg"></p>
<p>图2.5  Flexbox布局与主流浏览器的兼容性<br />React Native实现了Flexbox布局的大部分功能，并且在实际应用开发中也使用Flexbox来实现布局。这不仅使React Native的UI开发变得更加简单，还很好地解决了iOS、Android等屏幕适配的问题。<br />?提示：React Native中Flexbox布局的工作原理和Web开发基本一致，只有少许差异。例如，默认值不同，React Native中flexDirection属性的默认值是column而不是row，alignItems的默认值是stretch而不是flex-start，另外，flex只能指定一个数字值。<br />为了方便读者理解后面的代码，这里先简单介绍React Native开发中Flexbox布局的使用。<br />Flexbox布局所使用的属性，简单来说，可以分为以下两个。<br />?    决定子组件排列规则的属性，例如，flexDirection、flexWrap、justifyContent以及alignItems等。<br />?    决定组件自身显示规则的属性，例如，alignSelf以及flex等。<br />下面分别简单介绍这些属性。<br />2.4.1  flexDirection设置组件的排列<br />flexDirection属性表明组件中子组件的排列方向，取值有column（默认值）、row以及row-reverse。<br />例如，在不设置flexDirection的情况下，下面代码中的子组件view1和view2是按照默认值column纵向排列的，代码如下：</p>
<p>01    export default class flexbox extends Component {<br />02        render() {<br />03            return (<br />04                             // 页面根View<br />05                             // 子组件view1<br />06                             // 子组件view2<br />07                <br />08             );<br />09        }<br />10    }<br />11<br />12    const styles = StyleSheet.create({<br />13        container: {<br />14            flex: 1.backgroundColor:'gray',<br />15        },<br />16        view1: {                         //子组件view1的样式<br />17            height: 150,<br />18            width: 150,<br />19            backgroundColor: 'red'<br />20        },<br />21        view2: {                         //子组件view2的样式<br />22            height: 150,<br />23            width: 150,<br />24            backgroundColor: 'green'<br />25        }<br />26    });<br />?提示：为了节约篇幅，上述例子中只附上了关键代码，例如导入模块或组件的代码，形如import <em> from </em>。但是读者在实际开发过程中，千万不要忘记先导入相关模块或组件，否则会发生错误。<br />效果如图2.6所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzczZThiOTIwMzYxNjhmOTcwZDRmNWExNTk2NzExMjhmMjM3ODczMzAucG5n.jpg"></p>
<p>图2.6  flexDirection属性为column时的效果<br />当将flexDirection属性设置为row时，代码如下：</p>
<p>01    // 这里省略了没有修改的代码<br />02<br />03    const styles = StyleSheet.create({<br />04        container: {<br />05            flex: 1, backgroundColor.'gray',<br />06            flexDirection: 'row'<br />07        },<br />08        view1: {                 //子组件view1的样式<br />09            height: 150,<br />10            width: 150,<br />11            backgroundColor: 'red'<br />12        },<br />13        view2: {                 //子组件view2的样式<br />14            height: 150,<br />15            width: 150,<br />16            backgroundColor: 'green'<br />17        }<br />18    });</p>
<p>那么，子组件view1和view2将按照row进行横向排列，效果如图2.7所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzQwNDgyMmQ4ZGM5YTA0ODQxMjZiYjllNzUxMzcxZTg1Mjk5NzM0MDIucG5n.jpg"></p>
<p>图2.7  flexDirection属性为row时的效果<br /><strong>2.4.2  flexWrap设置是否换行</strong><br />flexWrap属性表明子组件“溢出”父组件时是否进行换行，取值有nowrap（默认值）、wrap以及wrap-reverse。<br />这里，所谓的溢出是指子组件显示的区域超出了父组件的空间。为了模拟溢出的效果，下面修改view1和view2的大小，代码如下：</p>
<p>01    // 这里省略了没有修改的代码<br />02<br />03    const styles = StyleSheet.create({<br />04        container: {<br />05            flex: 1, backgroundColor:'gray',<br />06            flexDirection: 'row'<br />07        },<br />08        view1: { <br />09            height: 200,<br />10            width: 200,             // 增大了view1的宽度<br />11            backgroundColor: 'red'<br />12        },<br />13        view2: { <br />14            height: 200,<br />15            width: 200,             // 增大了view2的宽度<br />16            backgroundColor: 'green'<br />17        }<br />18    });</p>
<p>由于没有设置flexWrap，所以当view2显示不全时，会按照默认值nowrap不进行换行，效果如图2.8所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzUyMDhkNGFjMGUwN2RmMDUzY2Y2MGI4ZTE4ODY1ODQwZWYzMjBhY2QucG5n.jpg"></p>
<p>图2.8  flexWrap属性为nowrap时的效果<br />当将flexWrap属性设置为wrap时，代码如下：</p>
<p>01    // 这里省略了没有修改的代码<br />02<br />03    const styles = StyleSheet.create({<br />04        container: {<br />05            flex: 1, backgroundColor:'gray',<br />06            flexDirection: 'row',<br />07            flexWrap: 'wrap'<br />08        },<br />09        view1: { <br />10            height: 200,<br />11            width: 200,<br />12            backgroundColor: 'red'<br />13        },<br />14        view2: { <br />15            height: 200,<br />16            width: 200, <br />17            backgroundColor: 'green'<br />18        }<br />19    });</p>
<p>此时，由于view2和view1的总宽度（200 + 200 = 400）大于屏幕的宽度（使用的iPhone 7宽度=375），所以view2将会换行显示，效果如图2.9所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2ZmMDMwMWRiMzZmY2RjNGRlM2I4MjE4ZWJkMzFlNzcwOWVkYmNhYzUucG5n.jpg"></p>
<p>图2.9  flexWrap属性为wrap时的效果<br /><strong>2.4.3  justifyContent设置横向排列位置</strong><br />justifyContent属性表明组件中子组件横向排列在其父容器的哪个位置，取值有flex-start、flex-end、center、space-between以及space-around。<br />例如，想要实现子组件水平居中的效果，就可以将justifyContent的值设置为center，代码如下：</p>
<p>01    // 这里省略了没有修改的代码<br />02<br />03    const styles = StyleSheet.create({<br />04        container: {<br />05            flex: 1, backgroundColor.'gray',<br />06            flexDirection: 'row',<br />07            justifyContent: 'center'<br />08        },<br />09        view1: { <br />10            height: 150,<br />11            width: 150,<br />12            backgroundColor: 'red'<br />13        },<br />14        view2: { <br />15            height: 150,<br />16            width: 150,<br />17            backgroundColor: 'green'<br />18        }<br />19    });</p>
<p>效果如图2.10所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2I1ZTRmYjM0ZWFkMjlmMmE0OTFjNTJjMGIzODMyODgyOWRmYmIzMWYucG5n.jpg"></p>
<p>图2.10  justifyContent属性为center时的效果<br /><strong>2.4.4  alignItems设置纵向排列位置</strong><br />alignItems属性表明组件中子组件纵向排列在其父容器的哪个位置，取值有flex-start、flex-end、center、baseline以及stretch。<br />alignItems属性和justifyContent的作用相似，只是justifyContent决定了子组件横向排列的位置，而alignItems决定了子组件纵向排列的位置。<br />如果想要实现子组件垂直居中的效果，那么就可以将alignItems的值设置为center，代码如下：</p>
<p>01    // 这里省略了没有修改的代码<br />02<br />03    const styles = StyleSheet.create({<br />04        container: {<br />05            flex: 1, backgroundColor:'gray',<br />06            flexDirection: 'row',<br />07            alignItems: 'center'<br />08        },<br />09        view1: { <br />10            height: 150,<br />11            width: 150,<br />12            backgroundColor: 'red'<br />13        },<br />14        view2: { <br />15            height: 150,<br />16            width: 150,<br />17            backgroundColor: 'green'<br />18        }<br />19    });</p>
<p>效果如图2.11所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tL2U1NTNlNGIzY2U1Yjc5MmNkZjdkMDc5MjU1MzAyZDE4YjY2YjRmMTgucG5n.jpg"></p>
<p>图2.11  alignItems属性为center时的效果<br />在了解了justifyContent和alignItems属性的用法之后，想必读者很容易就能够自己实现水平垂直居中的效果了，代码如下：</p>
<p>01    // 这里省略了没有修改的代码<br />02<br />03    const styles = StyleSheet.create({<br />04        container: {<br />05            flex: 1, backgroundColor:'gray',<br />06            flexDirection: 'row',<br />07            justifyContent: 'center',<br />08            alignItems: 'center'<br />09        },<br />10        view1: { <br />12            height: 150,<br />12            width: 150,<br />13            backgroundColor: 'red'<br />14        },<br />15        view2: { <br />16            height: 150,<br />17            width: 150,<br />18            backgroundColor: 'green'<br />19        }<br />20    });</p>
<p>水平垂直居中的效果如图2.12所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzUzNmU1MmZlY2Q2ODAzOTVhMmUxOTlkODVmZjgxMjg0ODYyZDNhMzQucG5n.jpg"></p>
<p>图2.12  使用justifyContent和alignItems属性实现水平垂直居中效果<br /><strong>2.4.5  alignSelf设置特定组件的排列</strong><br />alignSelf属性表明某个特定组件的排列情况，取值有auto、flex-start、flex-end、center以及stretch。<br />这里以center为例，代码如下：</p>
<p>01    // 这里省略了没有修改的代码<br />02<br />03    const styles = StyleSheet.create({<br />04        container: {<br />05            flex: 1, backgroundColor:'gray',<br />06        },<br />07        view1: { <br />08            height: 150,<br />09            width: 150,<br />10            backgroundColor: 'red'<br />11        },<br />12        view2: { <br />13            height: 150,<br />14            width: 150,<br />15            backgroundColor: 'green',<br />16            alignSelf: 'center'<br />17        }<br />18    });</p>
<p>效果如图2.13所示。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzY5OWQwNGRiYTI2NTI0ZTRmNWUxMmI1NjViNjUzMGQwZWYyYTVjYmQucG5n.jpg"></p>
<p>图2.13  alignSelf属性为center时的效果<br /><strong>2.4.6  flex设置组件所占空间</strong><br />flex属性可以让组件动态计算和配置自己所占用的空间大小，取值是数值。<br />如果想要view1和view2填满父组件，并且view1和view2的大小相同，使用flex就很容易实现，代码如下：</p>
<p>01    // 这里省略了没有修改的代码<br />02<br />03    const styles = StyleSheet.create({<br />04        container: {<br />05            flex: 1<br />06        },<br />07        view1: { <br />08            flex: 1,<br />09            backgroundColor: 'red'<br />10        },<br />11        view2: { <br />12            flex: 1,<br />13            backgroundColor: 'green'<br />14        }<br />15    });</p>
<p>效果如图2.14所示。<br />flex属性使用如此简单，但表现力却非常强大，它是Flexbox布局实现自适应设备和屏幕尺寸的核心，读者需要在后面的React Native开发中逐步熟练掌握flex属性的使用。<br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3lxZmlsZS5hbGljZG4uY29tLzFiMDQ4OWQyYjk3YjdjYzc3ZjMwNTU0YTg3NjQzMzNlYjFlNjVkY2UucG5n.jpg"></p>
<p>图2.14  使用flex属性实现自适应屏幕的尺寸大小</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-01 05:48:11</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/create/" title="Create">Create</a>, <a href="https://www.iamivan.net/tag/https/" title="HTTPS">HTTPS</a>, <a href="https://www.iamivan.net/tag/%e5%b8%83%e5%b1%80/" title="布局">布局</a>, <a href="https://www.iamivan.net/tag/native/" title="native">native</a>, <a href="https://www.iamivan.net/tag/react/" title="react">react</a>, <a href="https://www.iamivan.net/tag/image/" title="image">image</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>《React Native移动开发实战》一一2.4  React Native的Flexbox布局的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze6dLOb.html" rel="bookmark">《React Native移动开发实战》一一1&period;1  看透React Native</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.1 看透React Native React Native(http://facebook.github.io/react-native/)第一次进入公众的视野是在2015年1月的React.js Conf(http://conf.reactjs. org/)上,随后,同年5月份,Facebook在F8 Conference(https://www. fbf8.com/)上正式宣布:React Native项目(如图1.1所示) 在Github开源.结果一天之内,就收获了5000多颗星,受关			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baK3XPp.html" rel="bookmark">《React Native移动开发实战》出版啦</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				对不起,我来晚了 首先要感谢支持和关注我的朋友,感谢人邮的赵老师,还有公司的领导和同事,他们在我写作的过程中给了很多有用的信息,也给了很多有用的建议,为本书的写作提供了很大帮助.感谢,再次感谢!!! 工作6年多以来,一直想写一本自己的书,一方面是对自己工作经历的一个总结,也是对希望写一本书给曾经的自己一个交代,毕竟30岁的人了,搞不了几年的技术了. 我一直有写博客的习惯,喜欢将自己工作和生活的点滴写成博客,分享给大家.说说我写书的缘由吧,最近几年,特别是15年和16年,我朋友圈的好友陆续出了自己			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGEWX2M.html" rel="bookmark">《React Native移动开发实战》一一导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 随着手机和移动互联网技术的日益成熟,移动应用的领域也从如何开发,发展到如何更高效.更低成本地开发.传统的原生平台(iOS.Android)开发技术虽然比较成熟,但由于开发效率和成本的限制,已经越来越无法满足移动互联网应用的开发需求. 所以,具有简单.迅速.跨平台的优势,而且基于Web开发语言和布局技术的React Native得以迅速流行,并一举夺得跨平台开发技术的头筹. 目前市场上大多数React Native书籍主要以翻译和讲解官方文档为主,并未从开发实际应用出发,通过典型案例来指导读			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvG24ap.html" rel="bookmark">《React Native移动开发实战》一一1&period;2  React Native的特点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.2 React Native的特点 那么,作为跨平台应用开发的&quot;新贵&quot;,React Native相比其他跨平台技术到底有哪些优势呢?1.2.1 其一:Learn Once, Write Anywhere 这句话是React Native官网(http://facebook.github.io/react-native/)对React Native的概述,简单明了地概括了React Native的最大特点和优点. 只需要学习React Native这一种开发方式(包括平台.语言和开发			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBK3ooM.html" rel="bookmark">《React Native移动开发实战》一一1&period;3  搭建React Native开发环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.3 搭建React Native开发环境 &quot;磨刀不误砍柴工&quot;,在正式开发React Native应用之前,需要先搭建好React Native的开发环境.搭建React Native开发环境有以下几个主要步骤. 原生开发工具:iOS开发使用Xcode,Android开发使用Android Studio and SDK Tools. Node.js(https://nodejs.org/):React Native是借助Node.js,即JavaScript运行时来创建JavaScr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwxBnWb.html" rel="bookmark">《React Native移动开发实战》一一1&period;5  小试牛刀&mdash;&mdash;更改React Native项目源码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.5 小试牛刀--更改React Native项目源码 应用虽然已经运行起来了,但是到现在还没有看到或修改任何代码,读者是不是觉得意犹未尽呢?下面就来看看React Native项目的源码吧. 打开index.ios.js文件,可以看到与显示在设备上内容直接相关的代码: 01 export default class ch02 extends Component { // 每个页面可以理解成一个组件 02 render() { // 渲染页面的函数 03 return ( 04 // 页面根V			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlLZRqM.html" rel="bookmark">《React Native移动开发实战》一一2&period;1  开发具备的基础知识说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.1 开发具备的基础知识说明 日常生活中,人们越来越离不开的就是网购,因此,本书就以典型的电商类移动应用为例,向读者展示使用React Native设计.开发应用的全过程. 不过,在正式开发电商类移动应用之前,有必要先了解一些React Native开发的基础知识. 提示:本书面向对JavaScript有一定了解的读者,所以JavaScript相关知识本书不做深入解释,想要了解更多JavaScript知识,请读者参考相关书籍和教程. React Native开发中需要具备的基础知识如下. Gi			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBqoGM.html" rel="bookmark">《React Native移动开发实战》一一3&period;5  拖曳刷新列表&mdash;&mdash;RefreshControl组件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.5 拖曳刷新列表--RefreshControl组件 在3.4节中,我们完善了商品列表的功能:不仅优化了列表的布局,还添加了分割线等效果.不过,该App还缺少一个常用的功能,那就是拖曳刷新.虽然也可以添加一个&quot;刷新&quot;按钮用于响应用户请求,但是用户体验却没有拖曳好,而且,由于现在移动开发设备屏幕通常较小,额外添加按钮对界面设计影响也较大. ?小知识:用户体验(User Experience,简称UX或UE)是涉及一个人使用一个特定产品或系统或服务的有关行为.态度与情绪.用户体验包括实			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvm161b.html" rel="bookmark">《React Native移动开发实战》一一3&period;3  完善轮播广告&mdash;&mdash;Image组件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3.3 完善轮播广告--Image组件 之前的轮播广告页面显示的是简单的文字和背景色,接下来添加一些好看的图片作为轮播广告. React Native中用于图片显示的组件是Image.Image组件可以显示多种不同类型图片,包括网络图片.静态资源.临时的本地图片,以及本地磁盘上的图片(如相册)等.3.3.1 使用网络图片 这里先使用网络图片来看看Image的用法和效果.修改app.js代码如下: 01 export default class app extends Component { 02			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz7xYdb.html" rel="bookmark" class="title">Guava的异常工具类--Throwables</a>
					<div>
						Guava为我们提供了一个非常方便并且实用的异常处理工具类:Throwables类. 这个类的API可以参见:http://docs.guava-libraries.googlecode.com/gi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boj43z.html" rel="bookmark" class="title">java 基础数据类型</a>
					<div>
						数据|数据类型 1.简单数据类型 逻辑类型  boolean 文本类型  char,String(特殊类型) 整数类型  byte,short,int,long 浮点类型  double,float  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vbQqZZb.html" rel="bookmark" class="title">c&num;调用API显示内部局域网内的主机</a>
					<div>
						显示   //写这个程序,为了是显示局域网内的主机,然后通过用户点击选中的机器,检查是否该主机上安装有SQLSERVER,是为一个配置程序所写的//这里提供CODE,给有需要的朋友 //设置DLL必须 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv8Q1z.html" rel="bookmark" class="title">浅谈设计中的索引色</a>
					<div>
						说到索引色,也许很多朋友都没有接触过这一块儿. 首先,我们要说,为什么要用索引色图片?我们在设计PC界面的时候,用的几乎都是真彩色,不受颜色的限制,可以直接生成PNG:或者BMP加一个透明色,由工程师 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b36Lgz.html" rel="bookmark" class="title">在Pocket PC中使用Web Service连接数据库</a>
					<div>
						web|连接数据库 在Pocket PC中使用Web Service连接数据库前言微软的移动开发者大会在六月的北京举行了,国内的移动应用软件虽然是刚刚起步,但是这个前景宽广的领域已经受到越来越多软件厂 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpngxZz.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;推荐：把百度设为主页&rdquo; 你搜索时发现了吗</a>
					<div>
						本来是想找百度建议之类的现象,结果在搜索时,突然发现页面上多了一个部分,总觉得怪怪的.对比了下上周的截图,才发现了这个特别之处.不仔细看还真的发现不出,你搜索时发现了&quot;推荐:把百度设为主页& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDrNrM.html" rel="bookmark" class="title">Windows 8开发入门（十四） windows 8中粘贴板&lpar;剪切板&rpar;的使用</a>
					<div>
						在Windows 8中我们的粘贴板分别保存4种信息:文本.图片.网页.文件.在本文中我们将分别复制和粘 贴这4种元素,当然你也可以在外部复制这4种元素,然后在程序中粘贴出来. DataPackage: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKr7rp.html" rel="bookmark" class="title">存储虚拟化的最佳道路</a>
					<div>
						作为一种IT基本概念,&quot;虚拟化&quot;已经被运用了30多年.然而,虚拟化作为一种直接帮助企业用户降低IT成本.提高竞争力和利润的技术,在存储和服务器领域开花结果,更在最近几年呈现出蒸蒸日 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62AZAM.html" rel="bookmark" class="title">Word 2007在纸张背面进行双面打印</a>
					<div>
						当使用支持双面打印的打印机打印Word2007文档时,用户可以通过设置在纸张背面打印当前Word文档,以实现双面打印的目的,操作步骤如下所述: 第1步,打开Word2007文档窗口,依次单击&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAQJKb.html" rel="bookmark" class="title">如何有效地使用对话框</a>
					<div>
						Q:如何在对话框中加入工具条在 OnInitDialog 中加入下面代码: BOOL CYourDlg::OnInitDialog() { CDialog::OnInitDialog(); // Cr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1Z4jz.html" rel="bookmark" class="title">asp &lpar;author&colon;killer&rpar;禁止站外提交表单的代码</a>
					<div>
						  使用asp尽量减少服务器端的工作量,这样就应该多使用javascript,把所有提交字段使用javascript或vbscript检测后提交给服务器,这样服务器就不必再作检测,而在提交时可能会有人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK7ax5b.html" rel="bookmark" class="title">word2013怎么绘制笑脸？</a>
					<div>
						  word2013绘制笑脸步骤: 1.我们先看一下我们要达到的目标图,先有一个整体的映像. word2013 2.其实,我们知道中间的笑脸不难画,难点在笑脸外围的细长椭圆,我们数一下有24个.先画一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1E9WjM.html" rel="bookmark" class="title">win8&period;1如何简单关机</a>
					<div>
						使用win8系统的用户都在抱怨关机操作相当麻烦,而在win8.1系统中还是延续了win8系统的关机方法,让很多用户相当无奈,难道关个机就要一直这么麻烦吗?其实不是的,在win8.1系统中还有个简单的关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYXJKM.html" rel="bookmark" class="title">Win7系统error code 0x00000005错误解决方法</a>
					<div>
						  声卡驱动是一种可以使计算机和设备通信的特殊程序,可以说相当于硬件的接口,操作系统只有通过这个接口,才能控制硬件设备的工作,假如某设备的驱动程序未能正确安装,便不能正常工作. 因此,驱动程序被誉为& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1B8yb.html" rel="bookmark" class="title">如何授权一个子账号管理某2个DRDS实例</a>
					<div>
						您需要使用自定义授权策略的功能.这里例如您的实例ID是i-001和i-002: 首先您需要创建一条自定义授权策略,包含管理i-001和i-002的权限,不包含查看DRDS所有资源的权限: { &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8XnYb.html" rel="bookmark" class="title">彻底理解PHP的SESSION机制</a>
					<div>
						1.session.save_handler = files     * 1. session_start()          1. session_start()是session机制的开始,它有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32mL3z.html" rel="bookmark" class="title">MySQL5&period;5安装出现CMake错误找不到CMakelists&period;txt原因</a>
					<div>
						今天虚拟机上测试安装 CentOS6.3 + PHP5.4.8 + MySQL5.5.28,结果捣鼓了半天 MySQL都没装上,老是CMake目录下找不到那个 lists 文件,郁闷的不行,最后发现问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKY9Kz.html" rel="bookmark" class="title">eclipse调试窗口无法正常显示中文</a>
					<div>
						问题描述 如下图所示,输入中文后无法显示中文,而是现实一堆字母,如果输入英文就可以正常显示出来!请问这是怎么回事? 解决方案 解决方案二:就算是不正常显示中文也应该是乱码吧,怎么会变成汉语拼音呢,所以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBdQoM.html" rel="bookmark" class="title">静态方法中&comma;如何得到当前类名&quest;</a>
					<div>
						问题描述 在静态方法中,如何得到当前类名?如:classclass1{staticclass1getNew(){///这里,如何得到当前类名,即class1,///以实现用统一的方法自动创建当前类的实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RE0Bb.html" rel="bookmark" class="title">Android 文件存放路径【转】</a>
					<div>
						对于应用携带的静态数据,可以放置在应用的assets目录或者res,raw目录下. 对于assets目录下的静态数据,存在当文件最大支持1MB的局限,读取方式如下: 1 InputStream is  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12rjop.html" rel="bookmark" class="title">阿里云高性能计算HPC北京区域如何利用VPN访问公网</a>
					<div>
						背景 阿里云高性能计算HPC于2016年12月13日正式开通了北京区域的服务,相比于杭州区域的服务,北京区域同一个帐号下的HPC机器可以内网互通,但是仍然不能访问公网:本文将指导有访问公网需求的用户设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBdD3z.html" rel="bookmark" class="title">C&num;学习笔记&mdash;&mdash;简单的声音播放</a>
					<div>
						现在正在做一个简单的C#软件,为了美化和多媒体的东西,我需要在窗体启动的时候播放音乐,查找了MSDN找到了这个东西,记录一下以后使用! 源码: using System;using System.Ru ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22L9Bb.html" rel="bookmark" class="title">微软IE9增加的7大安全机制</a>
					<div>
						近日,微软发布了IE9 beta版.IE9是微软迄今为止支持标准最规范的IE浏览器.同时,IE9还改进了IE浏览器性能,增加了许多安全机制.下面我们来介绍一下微软IE9新增加的7大安全机制.1.沙盒技 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Qk4Ap.html" rel="bookmark" class="title">php批量添加数据与批量更新数据的实现方法&lowbar;php技巧</a>
					<div>
						本文实例讲述了php批量添加数据与批量更新数据的实现方法.分享给大家供大家参考.具体分析如下: php如果要批量保存数据我们只要使用sql的insert into语句就可能实现数据批量保存了,如果是更 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR1VV8b.html" rel="bookmark" class="title">Android中WebView无法后退和js注入漏洞的解决方案&lowbar;Android</a>
					<div>
						因重定向无法正常goBack()解决方案首先说下问题,初始页面为A,点击某个链接跳转到B(http://xxx.com.cn/),B页面重定向到C页面(http://xxx.com.cn/websit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxENomp.html" rel="bookmark" class="title">一个完整的类似ctrl&plus;f的功能</a>
					<div>
						&lt;style type=text/css&gt;BODY { FONT-FAMILY: &quot;宋体&quot;,&quot;Arial&quot;,&quot;Times New Roma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn818Kb.html" rel="bookmark" class="title">市场打新热情重新燃起本周12只新股申购</a>
					<div>
						近期新股上市表现较强,一级市场的打新热情又开始重新燃起.值得注意的是,本周又有12只新股发行.有市场分析人士认为,在资金不断收紧.上市公司再融资大量推出的情况下,将使市场资金更加紧张. 文/表 记者张 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqKrBp.html" rel="bookmark" class="title">网站原创文章不收录 尝试百度产品助力前进</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 很多站长看到这个标题不禁会产生疑问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3YYaAp.html" rel="bookmark" class="title">图片-这是哪里错了&comma;快点来看看</a>
					<div>
						问题描述 这是哪里错了,快点来看看 解决方案 第7行,println()里面怎么能定义变量?println()方法中需要传入一个String类型的参数,,如果你是想输出显示变量 i 的值,直接写成 p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7w8eZz.html" rel="bookmark" class="title">理想和现实中的自己</a>
					<div>
						对于没有做过的事情,我们会想象自己会做得怎么样,要么高估要么低估,做到准确无误真的不容易. 昨天因为一件小事,我和男朋友(我们已定亲)闹别扭了. 分别从我和他的角度来分析一下. 从我的角度,起始男朋友 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
